# Example API calls

- ## Organization

  ### List organizations (GET)

  ```
  curl http://localhost:4000/api/organization
  curl http://localhost:4000/api/organization/:id
  e.g.
  curl http://localhost:4000/api/organization/our-sci
  ```

  ### Create organization (POST)

  ```
  curl -X POST -H "Content-Type: application/json" -d '{"_id": "our-sci", "name": "Our-Sci"}' http://localhost:4000/api/organization
  ```

  ### Update organization (PUT)

  ```
  curl -X PUT -H "Content-Type: application/json" -d '{"_id": "our-sci", "name": "Our-Sci LLC"}' http://localhost:4000/api/organization/our-sci
  ```

  Note that the **\_id** field is used as the "handle".

- ## Soil depth

  ### List soil-depths (GET)

  ```
  curl http://localhost:4000/api/soildepth
  curl http://localhost:4000/api/soildepth/:id
  e.g.
  curl http://localhost:4000/api/soildepth/10_TO_20_CM
  ```

  ### Create soil-depth (POST)

  ```
  curl -X POST -H "Content-Type: application/json" -d '{"_id": "0_TO_10_CM", "name": "0 - 10 cm", "min_depth": 0, "max_depth": 10, "units": "CM"}' http://localhost:4000/api/soildepth
  ```

  ### Update soil-depth (PUT)

  ```
  curl -X PUT -H "Content-Type: application/json" -d '{"_id": "0_TO_10_CM", "name": "0 to 10cm"}' http://localhost:4000/api/soildepth/0_TO_10_CM
  ```

  Note that the **\_id** field is used as the "handle". Furthermore, when using PUT to update an entity, the last bit of the URL is case-sensitive ("0_TO_10_CM" is not the same as "0_to_10_cm"). If this is a problem, we could only allow lower-case names for \_id/handle.

- ## Sample

  ### List samples (GET)

  A sample has a **reference** named **soil_depth**. If you want to populate this reference, pass a populate query parameter.

  ```
  curl http://localhost:4000/api/sample
  curl http://localhost:4000/api/sample?populate=soil_depth
  curl http://localhost:4000/api/sample/:id
  e.g.
  curl http://localhost:4000/api/sample/5d7f72a9b543522bcdf64ecd
  curl http://localhost:4000/api/sample/5d7f72a9b543522bcdf64ecd?populate=soil_depth
  ```

  ### Create sample (POST)

  ```
  curl -X POST -H "Content-Type: application/json" -d '{"soil_depth": "10_TO_20_CM", "sample_id": "bsdf123", "timestamp": "2019-01-19T13:43:21.898Z"}' http://localhost:4000/api/sample

  curl -X POST -H "Content-Type: application/json" -d '{"soil_depth": "0_TO_10_CM", "sample_id": "asdf123", "timestamp": "2014-01-22T14:56:59.301Z"}' http://localhost:4000/api/sample

  curl -X POST -H "Content-Type: application/json" -d '{"soil_depth": "0_TO_10_CM", "sample_id": "asdf123", "timestamp": "2018-10-03T22:39:12.298Z"}' http://localhost:4000/api/sample
  ```

  ### Update sample (PUT)

  ```
  curl -X PUT -H "Content-Type: application/json" -d '{"_id": "5d7f72a9b543522bcdf64ecd", "soil_depth": "20_TO_30_CM"}' http://localhost:4000/api/sample/5d7f72a9b543522bcdf64ecd
  ```

  Note that the **\_id** field is auto-generated by mongodb.

- ## Sampling Event

  ### List Sampling events

  A sampling event has a **reference** named **samples**. If you want to populate this reference, pass a populate query parameter.

  ```
  curl http://localhost:4000/api/samplingevent
  curl http://localhost:4000/api/samplingevent?populate=samples
  curl http://localhost:4000/api/samplingevent/:id
  e.g.
  curl http://localhost:4000/api/samplingevent/5d7f75cab543522bcdf64ece
  curl http://localhost:4000/api/samplingevent/5d7f75cab543522bcdf64ece?populate=samples
  ```

  ### Create sampling event (POST)

  ```
  curl -X POST -H "Content-Type: application/json" -d '{"samples": ["5d7f6e70e623ab27ff8b6ae1"], "modified_at": "2019-09-16T13:43:21.898Z", "started_at": "2019-09-16T13:43:21.898Z", "completed_at": "2019-09-16T13:43:21.898Z"}' http://localhost:4000/api/samplingevent

  curl -X POST -H "Content-Type: application/json" -d '{"samples": [], "modified_at": null, "started_at": null, "completed_at": null}' http://localhost:4000/api/samplingevent
  ```

  ### Update sampling event (PUT)

  ```
  curl -X PUT -H "Content-Type: application/json" -d '{"completed_at": "2019-09-16T13:43:21.898Z"}' http://localhost:4000/api/samplingevent/5d7f72a9b543522bcdf64ecd
  ```

  Note that the **\_id** field is auto-generated by mongodb.

- ## Field

  ### List fields

  A field has a **reference** named **sampling_events**. If you want to populate this reference, pass a populate query parameter.

  ```
  curl http://localhost:4000/api/field
  curl http://localhost:4000/api/field?populate=sampling_events
  curl http://localhost:4000/api/field/:id
  e.g.
  curl http://localhost:4000/api/field/5d7f7c0da7f7ec34f300ff0d
  curl http://localhost:4000/api/field/5d7f7c0da7f7ec34f300ff0d?populate=sampling_events
  ```

  ### Create field (POST)

  ```
  curl -X POST -H "Content-Type: application/json" -d '{"name": "Field 1", "sampling_events": ["5d7f75cab543522bcdf64ece"], "geometry": {"coordinates": [[[-121.21853916959321, 37.765037215002636],[-120.73850845825076, 36.75901481152573], [-119.36242041906883, 37.95453275922172], [-120.67450436340502, 38.206434872085254]]], "type": "Polygon"}}' http://localhost:4000/api/field

  curl -X POST -H "Content-Type: application/json" -d '{"name": "Field 2", "sampling_events": [], "geometry": {"coordinates": [[[-122.7562035156246, 40.062320141059075],[-123.06382070312497, 39.50511291289541], [-122.40464101562465, 38.85790225917671], [-121.65757070312466, 39.369353448076964], [-122.7562035156246, 40.062320141059075]]], "type": "Polygon"}}' http://localhost:4000/api/field
  ```

  ### Update field (PUT)

  ```
  curl -X PUT -H "Content-Type: application/json" -d '{"geometry": {"coordinates": [[[-121, 37],[-120, 36], [-119, 37], [-120, 38]]], "type": "Polygon"}}' http://localhost:4000/api/field/5d7f7c0da7f7ec34f300ff0d
  ```

  Note that the **\_id** field is auto-generated by mongodb.
